class FileDescr {
private:
    const CString m_strFileName;
    const CString m_strAlternateFileName;
    const DWORD   m_dwSize;
    const CTime   m_CreationTime;
    const CTime   m_LastAccessTime;
    const CTime   m_LastWriteTime;
    
public:
    FileDescr( const WIN32_FIND_DATA& findData ) 
        : m_strFileName         ( findData.cFileName          )
        , m_strAlternateFileName( findData.cAlternateFileName )
        , m_dwSize              ( findData.nFileSizeLow       )
        , m_CreationTime        ( findData.ftCreationTime     )
        , m_LastAccessTime      ( findData.ftLastAccessTime   )
        , m_LastWriteTime       ( findData.ftLastWriteTime    )
    {
    }
    
    const CString& getFileName( void ) const {
        return m_strFileName;
    }
    
    const CString& getAlternateFileName( void ) const {
        return m_strAlternateFileName;
    }
    
    DWORD getSize( void ) const {
        return m_dwSize;
    }
    
    const CTime& getCreationTime( void ) const {
        return m_CreationTime;
    }
    
    const CTime& getLastAccessTime( void ) const {
        return m_LastAccessTime;
    }
    
    const CTime& getLastWriteTime( void ) const {
        return m_LastWriteTime;
    }
};
