// ListCtrl.h

class ListCtrl : public CListCtrl
{
public:
    ListCtrl() : 
      m_pmenuPopup( 0 ), m_nSortColumn( 0 ), m_bAscending( TRUE ) {}
      
private:
    int    m_nSortColumn;
    BOOL   m_bAscending;
    CMenu* m_pmenuPopup;
    
public:
    void Initialize( void );
    void Sort ( void ) {
        ASSERT_VALID( this );
        SortItems( CompareProc, reinterpret_cast<LPARAM>( this ) );
    }
    int GetColumnCount( void ) const {
        const CHeaderCtrl *pwndHeader = 
            static_cast< CHeaderCtrl *>( GetWindow( GW_CHILD ) );
        ASSERT( ::IsWindow( pwndHeader->GetSafeHwnd() ) );
        return pwndHeader->GetItemCount();
    }
    
protected:
    virtual void DoInitialize( void ) = 0;
    virtual void DoDestroy( void );
    virtual CString DoGetText ( 
        LPARAM lParam, int nColumn, BOOL bSorting = FALSE ) const = 0;
    virtual int DoGetSubColumn( 
        int nPrimaryColumn, int nSubColumn ) const = 0;
    
private:
    static int CALLBACK CompareProc (
        LPARAM lParam1,
        LPARAM lParam2,
        LPARAM lParam );
    
    void SetSortColumn( int nSortColumn );
    int GetSubColumn( int nSubColumn ) const {
        return DoGetSubColumn( m_nSortColumn, nSubColumn );
    }
    
    virtual BOOL OnCommand( WPARAM wParam, LPARAM lParam );
    afx_msg void OnColumnclick( NMHDR* pNMHDR, LRESULT* pResult );
    afx_msg void OnGetdispinfo( NMHDR* pNMHDR, LRESULT* pResult );
    afx_msg void OnContextMenu( CWnd* pWnd, CPoint point );
    afx_msg void OnDestroy();
    
    DECLARE_MESSAGE_MAP()
};

// end of file
